import { Observable } from '../Observable';
export function throwError(errorOrErrorFactory, scheduler) {
    if (!scheduler) {
        return new Observable((subscriber) => subscriber.error(typeof errorOrErrorFactory === 'function' ? errorOrErrorFactory() : errorOrErrorFactory));
    }
    else {
        return new Observable((subscriber) => scheduler.schedule(() => {
            subscriber.error(typeof errorOrErrorFactory === 'function' ? errorOrErrorFactory() : errorOrErrorFactory);
        }));
    }
}
//# sourceMappingURL=throwError.js.map